\section{Having \texorpdfstring{$n$}{n}-permutable congruences}
  \label{sec:n-permutability}

In this section, we will investigate both the strong Mal'cev conditions for
being congruence $n$-permutable (every two congruences $\alpha$, $\beta$ of
a~single algebra satisfy \( \alpha \circ_n \beta = \beta \circ_n \alpha \)) for
a~fixed $n$, and a~general condition of being congruence $n$-permutable for some
$n$. Therefore, we will speak about a~countable chain of filters in the
interpretability lattice and its limit. The primeness of the limit filter would
be implied by primeness of each of the filters from the chain.  Unfortunately,
we are not able to establish the version of Theorem \ref{thm:1.4}(ii) for the
filters from the chain.
We would also like to note that the condition of being $n$-permutable for some
$n$ can be also formulated as `having no nontrivial compatible partial order';
this have been attributed to Hagemann, for a~proof see \cite{freese13}.

\begin{theorem} \label{thm:5.1}
  A~variety $\var V$ is not congruence $n$-permutable for any $n$ if and only if
  it contains an algebra compatible with a~partial order that is not an
  antichain. \qed
\end{theorem}

There are two well-known Mal'cev characterizations of the discussed conditions,
the older $(n+1)$-ary terms by Schmidt \cite{schmidt69} and refined ternary
terms by Hagemann and Mitschke \cite{hagemann.mitschke73} (items (2) and (3),
respectively):

\begin{theorem} The following are equivalent for any variety $\var V$ and every
positive integer $n$.
\begin{enumerate}
  \item $\var V$ is $n$-permutable;
  \item there are $(n+1)$-ary $\var V$-terms $s_0,\dots,s_n$ such that
  the identities
    \begin{align*}
      s_0(x_0,\dots,x_n) &\equals x_0,\ s_n(x_0,\dots,x_n) \equals x_n, \\
      s_i(x_0,x_0,x_2,x_2,\dots) &\equals s_{i+1}(x_0,x_0,x_2,x_2,\dots)
        \text{ for odd $i$, and} \\
      s_i(x_0,x_1,x_1,x_3,\dots) &\equals s_{i+1}(x_0,x_1,x_1,x_3,\dots)
        \text{ for even $i$}
    \end{align*}
  are satisfied in $\var V$;
  \item there are ternary $\var V$-terms $p_0,\dots,p_n$ such that
  the identities
    \begin{align*}
      p_0(x,y,z) &\equals x,\ p_n(x,y,z) \equals z,\text{ and} \\
      p_i(x,x,y) &\equals p_{i+1}(x,y,y) \text{ for every $i < n$ }
    \end{align*}
  are satisfied in $\var V$. \qed
\end{enumerate}
\end{theorem}

\subsection{Colorings and linear varieties}

For the characterization of congruence $n$-permutable varieties in the means of
coloring, we will use the smallest structures with two equivalence relations
that do not $n$-permute (denoted $\rel W_n$) for the strong conditions, and the
two-element chain for the general condition.

\begin{definition}
For $n \geq 2$, we define the structure $\rel W_n$ as the relational structure
on $\{ 0,\dots, n \}$ with two binary equivalence relations $\alpha$ and $\beta$
defined by partitions $01|23|\dots$ and $0|12|34|\dots$, respectively.
\end{definition}

The the following is a~variation on a result of Sequeira \cite{sequeira01}, who
provided a~very similar characterization by the means of compatibility with
projections.

\begin{proposition} \label{prop:coloring-for-permutability}
  Let $n\geq 2$. A~variety is not congruence $n$-permutable if and only if has
  strongly $\rel W_n$-colorable terms.
\end{proposition}

\begin{proof}
  First we fix some notation. Let $\rel F$ denote the structure obtained from
  the free structure in $\var V$ generated by $\rel W_n$ by replacing each of
  its relations by its transitive closure. Again, as in the proof of
  Proposition~\ref{prop:coloring-for-modularity}, we obtain that all relations
  of $\rel F$ are equivalences, and $c\colon F \to W_n$ is a~coloring if and
  only if it is a~homomorphism from $\rel F$ to $\rel W_n$. Also, to simplify
  the notation, we identify an~$(n+1)$-ary term $s$ with $s(x_0,\dots,x_n)$.
  
  To prove the first implication, suppose that $\var V$ has Schmidt terms
  $s_0,\dots,s_n$. Our objective is to prove that terms of $\var V$ are not
  strongly $\rel W_n$-colorable. For the contrary, suppose that there is
  a~strong coloring $c\colon \rel F \to \rel W_n$.
  Any such coloring maps $x_0$, and therefore also $s_0$, to $0$. Further, from
  Schmidt identities we get that $(s_1,s_0) \in \beta^{\rel F}$, therefore also
  $c(s_1) = 0$. Following a~similar argument for pairs $(s_{i+1},s_i)$
  alternating between $\beta^{\rel F}$ and $\alpha^{\rel F}$, we obtain $c(s_i)
  < i$ for all $i>0$ which in particular implies that $c(x_n) = c(s_n) < n$,
  a~contradiction with $c(x_n) = n$.

  For the other implication, suppose that $\var V$ does not have Schmidt terms.
  Similarly as in the proof of Proposition~\ref{prop:coloring-for-modularity},
  we define a~coloring $c$ by setting $c(x_0) = 0$ and then, following
  Schmidt-like chains of terms, extend this definition as we are forced, and
  finally, setting $c(f) = n$ for all elements that have not been reached. This
  is summarized in the following definition:
  \[
    c(f) = \min
      \{ i : (x_0,f) \in \freeclo\beta\circ_{i+1} \freeclo\alpha \}
  \]
  if the set on the right hand side is non-empty, and $c(f) = n$, otherwise. By
  definition, we have that for each $i$, $c(x_i) \leq i$.  First, we need to
  show that $c$ is well-defined, in particular that $c(f) \leq n$ for all $f$.
  Suppose that $f$ satisfies $(x_0, f) \in \beta^{\rel F} \join \alpha^{\rel
  F}$. Immediately, we get that $f$ is idempotent, i.e., $f(x_0,\dots,x_0) =
  x_0$. Also, since
  \(
    (x_0,x_i) \in
      \alpha^{\rel F} \circ_{i} \beta^{\rel F} \subseteq
      \beta^{\rel F} \circ_{n+1} \alpha^{\rel F}
  \)
  for all $i$, and $\beta^{\rel F} \circ_{n+1} \alpha^{\rel F}$ is
  a~subuniverse,
  $(x_0,f) \in \beta^{\rel F} \circ_{n+1} \alpha^{\rel F}$.
  Therefore, the aforementioned set contains $n$, and we have $c(f) \leq n$.

  Next, we show that $c$ is compatible with $\alpha$ and $\beta$.  Suppose that
  $(f,g) \in \freeclo \alpha$ and both $f$ and $g$ are idempotent. Without loss
  of generality, suppose that $c(f) \leq c(g)$. If $c(f)$ is an odd number, then
  $c(g) \leq c(f)$; if $c(f)$ is even, then $c(g) \leq c(f) + 1$. Altogether, we
  have that $(c(g),c(f))$ differ by at most 1, and if they do, then $c(f)$ is
  odd and $c(g) = c(f) + 1$. This gives that $(c(f),c(g)) \in \alpha^{\rel
  W_n}$. Similarly, we get that $c$ is compatible with $\beta$, therefore $c$ is
  a~coloring.

  Lastly, we need to show that $c$ is strong. As mentioned before, $(x_0,x_i)
  \in \beta^{\rel F} \circ_{i+1} \alpha^{\rel F}$, therefore $c(x_i) \leq i$ for
  all $i$. For a~contradiction suppose that $c(x_i) < i$ for some $i$, i.e.,
  $(x_0,x_i) \in \beta^{\rel F} \circ_i \alpha^{\rel F}$.
  This implies that there are terms $x_0 = t_0$, $t_1$, \dots, $t_i = x_i$ with
  $(t_j,t_{j+1}) \in \beta^{\rel F}$ for even $j$ and $(t_j,t_{j+1}) \in
  \alpha^{\rel F}$ for odd $j$. Now, define $(i+1)$-ary terms $s_0,\dots,s_i$ by
  putting:
  \[
    s_j (x_0,\dots,x_i) = t_j (x_0,\dots,x_i,x_i,\dots,x_i).
  \]
  We claim that these terms satisfy Schmidt identities. Indeed, $s_0 = x_0$,
  $s_i = x_i$, $s_j(x_0,x_0,x_2,\dots) = s_{j+1}(x_0,x_0,x_2,\dots)$ for odd
  $j$, since $(t_j,t_{j+1}) \in \alpha^{\rel F}$ for such $j$, and
  $s_j(x_0,x_1,x_1,\dots) = s_{j+1}(x_0,x_1,x_1,\dots)$ for even $j$, since
  $(t_j,t_{j+1}) \in \beta^{\rel F}$ for such $j$.
  This gives is a~contradiction with the fact that $\var V$ is
  not even congruence $n$-permutable.
\end{proof}

The corresponding result for the general Mal'cev condition was proven
in~\cite{barto.oprsal.ea15}.

\begin{proposition} [{\cite[Proposition 7.2]{barto.oprsal.ea15}}]
  \label{prop:barto.oprsal.pinsker-n-perm}
  A~variety is not $n$-permutable for any $n$ if and only if it has strongly
  $(\{0,1\},\leq)$-colorable terms. \qed
\end{proposition}


\subsection{Idempotent varieties}

The fact, that the interpretability join of two idempotent varieties that are
not congruence $n$-permutable for any $n$ is not congruence $n$-permutable
either, follows from a~result of Valeriote and Willard
\cite{valeriote.willard14}. No similar result about the corresponding strong
Mal'cev conditions is known.

\begin{theorem}[\cite{valeriote.willard14}] \label{thm:valeriote.willard}
  An~idempotent variety is not $n$-permutable for any $n$ if and only if it is
  interpretable in the variety of distributive lattices. \qed
\end{theorem}

An important step to unify this result with the similar for linear varieties is
the observation that the variety of actions of idempotent polymorphisms of
$(\{0,1\},\leq)$ is interpretable in the variety of distributive lattices and
vice-versa. This is implicitly hidden in \cite{valeriote.willard14}: The key
reasons are that the clone of the two-element lattice on $\{0,1\}$ coincides with
the clone of idempotent polymorphisms of $\leq$, and that the two element
lattice generates the variety of ditributive lattices. As a~direct consequence
of this observation and the above theorem, we get:

\begin{corollary} \label{cor:valeriote.willard}
  An~idempotent variety is not $n$-permutable for any $n$ if and only if it
  contains an~algebra compatible with $(\{0,1\},\leq)$. \qed
\end{corollary}

\subsection{Proofs of Theorems~\ref{thm:overview-introduction}(ii) and
\ref{thm:permutability-introduction}}

First, we address Theorem~\ref{thm:overview-introduction}(ii):
We have showed that if a~variety is not $n$-permutable for any $n$ and it is
either linear, or idempotent then it contains an algebra compatible with
$(\{0,1\},\leq)$ (the linear case follows from
Proposition~\ref{prop:barto.oprsal.pinsker-n-perm} and
Lemma~\ref{lem:linear-varieties}, the idempotent case from Corollary
\ref{cor:valeriote.willard}).  Therefore, given $\var V$ and $\var W$ that are
not $n$-permutable for any $n$ and are both linear, or idempotent, we know that
both contain an algebra that is compatible with $(\{0,1\},\leq)$.
Lemma~\ref{lem:joins} then gives that there is an algebra in $\var V\join \var
W$ that is compatible with this partial order, and therefore witnesses that
$\var V \join \var W$ is not $n$-permutable for any $n$ (see
Theorem~\ref{thm:5.1}).

Theorem~\ref{thm:permutability-introduction} is obtained in a~similar way:
Using Proposition~\ref{prop:coloring-for-permutability} and
Lem\-ma~\ref{lem:linear-varieties}, we get that any linear variety, that is not
$n$-permutable for a~fixed $n$, contains an algebra that is compatible with $\rel
W_n$, therefore also the join of two such varieties contains an algebra
compatible with $\rel W_n$. Having such an~algebra contradicts being
congruence $n$-permutable. \qed
